# -*- coding: UTF-8 -*-
#Coders Nikolasi
from Components.Converter.Converter import Converter
from Components.config import config
from Components.Element import cached, ElementError
from enigma import iServiceInformation, eServiceReference, eServiceCenter, iPlayableServicePtr
from ServiceReference import ServiceReference
from Tools.Directories import fileExists
import os, sys

class MovieInfo(Converter, object):
	MOVIE_SHORT_DESCRIPTION = 0 # meta description when available.. when not .eit short description
	MOVIE_META_DESCRIPTION = 1 # just meta description when available
	MOVIE_REC_SERVICE_NAME = 2 # name of recording service
	MOVIE_REC_FILESIZE = 3 # filesize of recording
	MOVIE_REC_NAME = 4 # name of movie
	MOVIE_FULL_DESCRIPTION = 5
	MOVIE_COUNTRY = 6
	MOVIE_GENRE = 7
	MOVIE_DESCRIPTION = 8
	MOVIE_ACTORS = 9	
	MOVIE_RATINGALL = 10
	MOVIE_RATINGCOUT = 11
	MOVIE_DIRECTOR = 12
	MOVIE_YEAR = 13
	
	def __init__(self, type):
		if type == "ShortDescription":
			self.type = self.MOVIE_SHORT_DESCRIPTION
		elif type == "FullDescription":
			self.type = self.MOVIE_FULL_DESCRIPTION
		elif type == "Description":
			self.type = self.MOVIE_DESCRIPTION
		elif type == "Director":
			self.type = self.MOVIE_DIRECTOR
		elif type == "Year":
			self.type = self.MOVIE_YEAR				
		elif type == "Genre":
			self.type = self.MOVIE_GENRE
		elif type == "Actors":
			self.type = self.MOVIE_ACTORS
		elif type == "Coutry":
			self.type = self.MOVIE_COUNTRY
		elif type == "Ratingall":
			self.type = self.MOVIE_RATINGALL
		elif type == "Ratingcount":
			self.type = self.MOVIE_RATINGCOUT			
		elif type == "MetaDescription":
			self.type = self.MOVIE_META_DESCRIPTION
		elif type == "RecordServiceName":
			self.type = self.MOVIE_REC_SERVICE_NAME
		elif type == "FileSize":
			self.type = self.MOVIE_REC_FILESIZE
		elif type == "MovieName":
			self.type = self.MOVIE_REC_NAME			
		else:
			raise ElementError("'%s' is not <ShortDescription|MetaDescription|RecordServiceName|FileSize> for MovieInfo converter" % type)
		Converter.__init__(self, type)

	@cached
	def getText(self):
                defaultpath = "/media/hdd/movie/"
                dircontrol = False
                eitcontrol = False
                txtcontrol = False
                ts = False
                Country = ''
                Country2 = ''
                genre = ''
                descript = ''
                ratingall = ''
                actors = ''
                fail = ''
                name = ""
                name2 = ""                
                description = ''
                year = ''
                director = ''
                namefil = ''
                eventName = ''
                filename = ''
                namecoverts = ''
                ext = ''
                nameext = ''
                nameext2 = ''                
                altext = ''
                altname = ''
		service = self.source.service
		if service:
                        import os.path
                        if isinstance(service, iPlayableServicePtr):
                                info = service and service.info()
                                ref = False
                                refstr = info.getInfoString(iServiceInformation.sServiceref)
                                path = refstr and eServiceReference(refstr).getPath()
                                if path != "":
                                     ts = True                                        
                                     filename = '%s' % (path)
                                else:
                                     name = info.getName()
                                     name2 = config.movielist.last_videodir.value                                        
                                     filename = '%s%s' % (name2, name)
                        else:
                                filename = service.getPath()
                                ref = True
                                info = self.source.info
                        if ref:        
                                if service and (service.flags & eServiceReference.isDirectory):
                                    number = '%s' % (os.path.dirname(filename))
                                    if number.endswith("VIDEO_TS"):
                                           number = number[:-9]
	                            if number != "":
                                         dircontrol = True   
	                                 p = os.path.split(number)
	                                 if not p[1]:
		                              p = os.path.split(p[0])
                                         namefil = '%s' % (p[1])
                                         if config.plugins.tmbd.movieselectionparts.value == "none":
                                               name = number + '.txt'
                                         else:
                                               nameext = config.plugins.tmbd.movieselectionparts.value + "/" + namefil + '.txt'
                                               if fileExists(nameext):
                                                       name = nameext
                                               else:
                                                       name = number + '.txt'
                                else:
                                      if config.plugins.tmbd.movieselectionparts.value == "none":  
                                                nameext = filename[:-2] + 'txt'
                                                if fileExists(nameext):
                                                        name = nameext
                                                else:
                                                        if filename != "":
                                                                altext = os.path.split(filename)[0]
                                                                name = altext + '.txt'
                                      else:
                                             altext, ext = os.path.split(filename)
                                             nameext = config.plugins.tmbd.movieselectionparts.value + "/" + ext[:-2] + 'txt'
                                             nameext2 = filename[:-2] + 'txt'
                                             if fileExists(nameext):
                                                     name = nameext
                                             elif fileExists(nameext2) and  not fileExists(nameext):
                                                    name = nameext2
                                             else:        
                                                namefil = self.getalttext(altext)
                                                name = config.plugins.tmbd.movieselectionparts.value + "/" + namefil + '.txt'
                        else:
                                if config.plugins.tmbd.movieselectionparts.value == "none":  
                                        nameext = filename[:-2] + 'txt'
                                        if fileExists(nameext):
                                                name = nameext
                                        else:
                                                if filename != "":
                                                        altext = os.path.split(filename)[0]
                                                        name = altext + '.txt'
                                else:
                                        altext, ext = os.path.split(filename)
                                        nameext = config.plugins.tmbd.movieselectionparts.value + "/" + ext[:-2] + 'txt'
                                        nameext2 = filename[:-2] + 'txt'
                                        if fileExists(nameext):
                                                name = nameext
                                        elif fileExists(nameext2) and  not fileExists(nameext):
                                                name = nameext2
                                        else:        
                                                namefil = self.getalttext(altext)
                                                name = config.plugins.tmbd.movieselectionparts.value + "/" + namefil + '.txt'                                
                        if fileExists(name):
                                txtcontrol = True
                                readmetafile = open(name, "r")                      
                        else:
                                if dircontrol:
                                        if config.plugins.tmbd.movieselectionparts.value == "none":
                                               name = number + '.eit'
                                        else:
                                               nameext = config.plugins.tmbd.movieselectionparts.value + "/" + namefil + '.eit'
                                               nameext2 = defaultpath + namefil + '.eit'
                                               if fileExists(nameext):
                                                       name = nameext
                                               else:
                                                       name = nameext2
                                else:
                                        if config.plugins.tmbd.movieselectionparts.value == "none":  
                                                nameext = filename[:-2] + 'eit'
                                                if fileExists(nameext):
                                                        name = nameext
                                                else:
                                                        if filename != "":
                                                                altext = os.path.split(filename)[0]
                                                                name = altext + '.eit'
                                        else:
                                                altext, ext = os.path.split(filename)
                                                nameext = config.plugins.tmbd.movieselectionparts.value + "/" + ext[:-2] + 'eit'
                                                nameext2 = filename[:-2] + 'eit'
                                                if fileExists(nameext):
                                                        name = nameext
                                                elif fileExists(nameext2) and  not fileExists(nameext):
                                                        name = nameext2
                                                else:
                                                        namefil = self.getalttext(altext)                                  
                                                        name = config.plugins.tmbd.movieselectionparts.value + "/" + namefil + '.eit' 
                                if fileExists(name):
                                      from Plugins.Extensions.TMBD import event
                                      evt = event.Event()
                                      evt.readFromFile(name)
                                      fail = '%s' % (evt.getShortDescription() + evt.getExtendedDescription())                                
                                      if fail != "":
                                          eitcontrol = True    
                                          import StringIO    
                                          readmetafile = StringIO.StringIO(fail)
                        if eitcontrol or txtcontrol:
			            try:
				         Country2 = readmetafile.readline()[0:-1]
				         if "Страна:" in Country2:
				                 if config.plugins.tmbd.movieInfo.value:
                                                       Country = Country2.replace('Страна: ', '')
                                                 else:
                                                       Country = Country2  
                                         else:
                                                 Country = '' 
			            except:
				         Country = ''                                
			            try:
				        genre = readmetafile.readline()[0:-1]
				        if config.plugins.tmbd.movieInfo.value:
                                                genre = genre.replace('Жанр: ', '')
			            except:
                                        genre = '' 
			            try:
				         descript = readmetafile.readline()[0:-1]
			            except:
				         descript = ''                                
			            try:
				        ratingall = readmetafile.readline()[0:-1]
			            except:
                                        ratingall = '' 
			            try:
				        actors = readmetafile.readline()[0:-1]
				        if config.plugins.tmbd.movieInfo.value:
                                                actors = actors.replace('В ролях: ', '')				        
			            except:
                                        actors = ''
			            try:
				        director = readmetafile.readline()[0:-1]
				        if config.plugins.tmbd.movieInfo.value:
                                                director = director.replace('Режиссер: ', '')				        
			            except:
                                        director = ''
			            try:
				        year = readmetafile.readline()[0:-1]
				        if config.plugins.tmbd.movieInfo.value:
                                                year = year.replace('Год выпуска: ', '')				        
			            except:
                                        year = ''
                                    readmetafile.close()  
			if self.type == self.MOVIE_SHORT_DESCRIPTION:
                                return Country +"\n"+ genre or ""                                                 
			elif self.type == self.MOVIE_FULL_DESCRIPTION:
                                if txtcontrol:
                                        return Country +"\n"+ genre +"\n"+ descript +"\n"+ actors +"\n"+ director +"\n"+ year  or "" 
                                else:
                                        return fail or ""
			elif self.type == self.MOVIE_DIRECTOR:
                                return director or ""
			elif self.type == self.MOVIE_YEAR:
                                return year or ""                        
			elif self.type == self.MOVIE_GENRE:
                                return genre or ""                         
			elif self.type == self.MOVIE_ACTORS:
                                return actors or ""
			elif self.type == self.MOVIE_DESCRIPTION:
                                if descript != "":
                                        description = descript
                                elif descript == "" and fail != "":
                                        description = fail    
                                return description or ""
			elif self.type == self.MOVIE_COUNTRY:
                                return Country or ""
			elif self.type == self.MOVIE_RATINGALL:
                                return ratingall or ""
			elif self.type == self.MOVIE_RATINGCOUT:
                                if 'Рейтинг:' in ratingall:
                                        name = ratingall.split('Рейтинг:')[1].split('.')[0].strip()
                                else:
                                        name = ""
                                return name or ""                        
			elif self.type == self.MOVIE_META_DESCRIPTION:
                                return Country +"\n"+ genre or ""
			elif self.type == self.MOVIE_REC_NAME:
                                eventName=""
                                if dircontrol:
                                    eventName = namefil
                                else:        
	                            if filename != "":
                                            altname, name = os.path.split(filename) or ''
                                            if ref:
                                                if name.endswith('.ts'):
                                                        name = service and info.getName(service) or ''
                                            else:
                                                if ts:
                                                   name = info.getName()                                                        
 	                                    counttochra = int(name.count("."))
	                                    if "_" in name:
                                                 name = name.replace("_", " ")
	                                    if counttochra > 1:
                                                cont = counttochra - 1
                                                name = name.replace(".", " ", cont)
                                            path = '/media/hdd/covers/'    
                                            if fileExists(path + name + '.jpg'):     
	                                        eventName = name
	                                    else:
                                                eventName = self.getalttext2(altname)     
	                            else:
                                            eventName = ""  
	                        return eventName
			elif self.type == self.MOVIE_REC_SERVICE_NAME:
				name = eventName
				return name 
			elif self.type == self.MOVIE_REC_FILESIZE:
                                if fileExists(filename):
				      filesize = int(os.stat(filename).st_size)
				      if filesize is not None:
                                	   return "%d MB" % (filesize / (1024*1024))
				else:                                	
					   return "0 MB"
		return ""

	text = property(getText)

	def getalttext(self, filename):
                name = ""
                if filename != "":
	                p = os.path.split(filename)
	                if not p[1]:
		                p = os.path.split(p)
                        name = '%s' % (p[1])                  
	        return name

	def getalttext2(self, filename):
                name = ""
                if filename != "":
	                p = os.path.split(filename)
	                if not p[1]:
		                p = os.path.split(p)
                        name = '%s' % (p[1])
                        counttochra = int(name.count("."))
	                if "_" in name:
                                name = name.replace("_", " ")
	                if counttochra > 1:
                                cont = counttochra - 1
                                name = name.replace(".", " ", cont)                                
	        return name
	
